Redmine - Feature #42441

Improve error message on role deletion by listing projects using the role
2025-03-19 08:49 - Mizuki ISHIKAWA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Administration Estimated time: 0.00 hour
Target version: 6.1.0

Resolution: Fixed

Description

Currently, when attempting to delete a role that is in use, the following message is displayed: This role is in use and cannot be
deleted.

However, this message does not provide enough information to understand which projects are using the role and how to resolve
the issue.

Proposal:
Enhance the error message to include a list of projects where this role is currently assigned to members.
For example:
screenshot 2025-03-19 16.39.34.png
Clicking on the project link will take you to the members tab of the settings for that project.

This way, the user can easily identify which project members they need to update before they can delete the role.
A similar improvement was made in #12521 to display detailed information in error messages for better guidance.

Associated revisions

Revision 23619 - 2025-04-10 12:14 - Go MAEDA

Improve role deletion error message to display projects containing members under the role (#42441).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

Revision 23620 - 2025-04-10 12:15 - Go MAEDA
Update locales (#42441).

History

#1 - 2025-03-19 08:50 - Mizuki ISHIKAWA

- File 0001-Improve-role-deletion-error-message-to-display-proje.patch added

Attached is a patch that adds a project link to the error message

#2 - 2025-03-24 10:25 - Go MAEDA

- Target version set to 6.1.0

Setting the target version to 6.1.0.

#3 - 2025-04-07 11:10 - Go MAEDA
- Assignee set to Mizuki ISHIKAWA

In the suggested patch, the projects variable set at the following line in RolesController#destroy does not appear to be used.
Could you check the patch?

projects = Project.joins (:members) .where (members: { role_id: @role.id }).distinct.sorted

#4 - 2025-04-09 08:22 - Mizuki ISHIKAWA

- File 0001-Improve-role-deletion-error-message-to-display-proje.patch added

Go MAEDA wrote in #note-3:
https://www.redmine.org/issues/12521

In the suggested patch, the projects variable set at the following line in RolesController#destroy does not appear to be used.
Could you check the patch?

(-]

You're right. There was an issue with the patch, so I've re-attached the corrected version.

#5 - 2025-04-10 12:16 - Go MAEDA
- Status changed from New to Closed
- Assignee changed from Mizuki ISHIKAWA to Go MAEDA

- Resolution set to Fixed

Committed the patch in r23619. Thank you.

Files

screenshot 2025-03-19 16.39.34.png 118 KB 2025-03-19 Mizuki ISHIKAWA
0001-Improve-role-deletion-error-message-to-display-proje.patch 3.67 KB 2025-03-19 Mizuki ISHIKAWA
0001-Improve-role-deletion-error-message-to-display-proje.patch 3.66 KB 2025-04-09 Mizuki ISHIKAWA
